
/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 * File: kinematics.c
 *
 * MATLAB Coder version            : 5.4
 */

/* Include Files */
#include "kinematics.h"
#include <math.h>

/* Function Definitions */
/*
 * function J2P_jt = kin_xyzbc_tt_J2P_jt(in1,in2,in3,in4)
 *
 * kin_xyzbc_tt_J2P_jt
 *     J2P_jt = kin_xyzbc_tt_J2P_jt(IN1,IN2,IN3,IN4)
 *
 * Arguments    : const double in1[5]
 *                const double in2[5]
 *                const double in3[5]
 *                double in4[5][3]
 *                double J2P_jt[5][5]
 * Return Type  : void
 */
void kin_xyzbc_tt_J2P_jt(const double in1[5], const double in2[5], const double in3[5],
                         double in4[5][3], double J2P_jt[5][5])
{
    double b_t2[25];
    double ab_t2_tmp;
    double ac_t2_tmp;
    double b_t2_tmp;
    double b_t2_tmp_tmp;
    double bb_t2_tmp;
    double bc_t2_tmp;
    double c_t2_tmp;
    double c_t2_tmp_tmp;
    double cb_t2_tmp;
    double cc_t2_tmp;
    double d_t2_tmp;
    double d_t2_tmp_tmp;
    double db_t2_tmp;
    double dc_t2_tmp;
    double e_t2_tmp;
    double eb_t2_tmp;
    double ec_t2_tmp;
    double f_t2_tmp;
    double fb_t2_tmp;
    double fc_t2_tmp;
    double g_t2_tmp;
    double gb_t2_tmp;
    double gc_t2_tmp;
    double h_t2_tmp;
    double hb_t2_tmp;
    double hc_t2_tmp;
    double i_t2_tmp;
    double ib_t2_tmp;
    double ic_t2_tmp;
    double j_t2_tmp;
    double jb_t2_tmp;
    double jc_t2_tmp;
    double k_t2_tmp;
    double kb_t2_tmp;
    double kc_t2_tmp;
    double l_t2_tmp;
    double lb_t2_tmp;
    double lc_t2_tmp;
    double m_t2_tmp;
    double mb_t2_tmp;
    double mc_t2_tmp;
    double n_t2_tmp;
    double nb_t2_tmp;
    double nc_t2_tmp;
    double o_t2_tmp;
    double ob_t2_tmp;
    double oc_t2_tmp;
    double p_t2_tmp;
    double pb_t2_tmp;
    double q_t2_tmp;
    double qb_t2_tmp;
    double r_t2_tmp;
    double rb_t2_tmp;
    double s_t2_tmp;
    double sb_t2_tmp;
    double t2;
    double t2_tmp;
    double t2_tmp_tmp;
    double t3;
    double t4;
    double t5;
    double t6;
    double t7;
    double t_t2_tmp;
    double tb_t2_tmp;
    double u_t2_tmp;
    double ub_t2_tmp;
    double v_t2_tmp;
    double vb_t2_tmp;
    double w_t2_tmp;
    double wb_t2_tmp;
    double x_t2_tmp;
    double xb_t2_tmp;
    double y_t2_tmp;
    double yb_t2_tmp;
    int i;
    int i1;
    /*     This function was generated by the Symbolic Math Toolbox version 9.1. */
    /*     07-Nov-2023 14:54:38 */
    /* Jacobian second derivative ( Inverse Kinematics ) :  */
    /* INPUTS :  */
    /* 	r_t    (5x1) : pose vector ( piece frame ) */
    /* 	v_t    (5x1) : speed vector ( piece frame ) */
    /* 	a_t    (5x1) : acceleration vector( piece frame ) */
    /* 	j_t    (5x1) : jerk vector( piece frame ) */
    /* 	p      (3x5) : parameters */
    /* OUTPUTS :  */
    /* 	M      (5x5) : resulting matrix */
    /* 'kin_xyzbc_tt_J2P_jt:18' b = in1(4,:); */
    /* 'kin_xyzbc_tt_J2P_jt:19' c = in1(5,:); */
    /* 'kin_xyzbc_tt_J2P_jt:20' offB1 = in4(10); */
    /* 'kin_xyzbc_tt_J2P_jt:21' offC1 = in4(13); */
    /* 'kin_xyzbc_tt_J2P_jt:22' offB3 = in4(12); */
    /* 'kin_xyzbc_tt_J2P_jt:23' offC2 = in4(14); */
    /* 'kin_xyzbc_tt_J2P_jt:24' offC3 = in4(15); */
    /* 'kin_xyzbc_tt_J2P_jt:25' offP1 = in4(7); */
    /* 'kin_xyzbc_tt_J2P_jt:26' offP2 = in4(8); */
    /* 'kin_xyzbc_tt_J2P_jt:27' offP3 = in4(9); */
    /* 'kin_xyzbc_tt_J2P_jt:28' tp1 = in2(1,:); */
    /* 'kin_xyzbc_tt_J2P_jt:29' tp2 = in2(2,:); */
    /* 'kin_xyzbc_tt_J2P_jt:30' tp3 = in2(3,:); */
    /* 'kin_xyzbc_tt_J2P_jt:31' tp4 = in2(4,:); */
    /* 'kin_xyzbc_tt_J2P_jt:32' tp5 = in2(5,:); */
    /* 'kin_xyzbc_tt_J2P_jt:33' tpp1 = in3(1,:); */
    /* 'kin_xyzbc_tt_J2P_jt:34' tpp2 = in3(2,:); */
    /* 'kin_xyzbc_tt_J2P_jt:35' tpp3 = in3(3,:); */
    /* 'kin_xyzbc_tt_J2P_jt:36' tpp4 = in3(4,:); */
    /* 'kin_xyzbc_tt_J2P_jt:37' tpp5 = in3(5,:); */
    /* 'kin_xyzbc_tt_J2P_jt:38' x = in1(1,:); */
    /* 'kin_xyzbc_tt_J2P_jt:39' y = in1(2,:); */
    /* 'kin_xyzbc_tt_J2P_jt:40' z = in1(3,:); */
    /* 'kin_xyzbc_tt_J2P_jt:41' t2 = cos(b); */
    t2 = cos(in1[3]);
    /* 'kin_xyzbc_tt_J2P_jt:42' t3 = cos(c); */
    t3 = cos(in1[4]);
    /* 'kin_xyzbc_tt_J2P_jt:43' t4 = sin(b); */
    t4 = sin(in1[3]);
    /* 'kin_xyzbc_tt_J2P_jt:44' t5 = sin(c); */
    t5 = sin(in1[4]);
    /* 'kin_xyzbc_tt_J2P_jt:45' t6 = tp4.^2; */
    t6 = in2[3] * in2[3];
    /* 'kin_xyzbc_tt_J2P_jt:46' t7 = tp5.^2; */
    t7 = in2[4] * in2[4];
    /* 'kin_xyzbc_tt_J2P_jt:47' et1 =
     * t2.*tpp3+offB1.*t4.*t6-offB3.*t2.*t6-offC3.*t2.*t6-offP3.*t2.*t6-offB1.*t2.*tpp4-offB3.*t4.*tpp4-offC3.*t4.*tpp4-offP3.*t4.*tpp4-t3.*t4.*tpp1+t4.*t5.*tpp2-t4.*tp3.*tp4.*2.0-t2.*t6.*z-t4.*tpp4.*z+offC1.*t3.*t4.*t6+offC1.*t3.*t4.*t7-offC2.*t4.*t5.*t6-offC2.*t4.*t5.*t7+offP1.*t3.*t4.*t6+offP1.*t3.*t4.*t7-offP2.*t4.*t5.*t6-offP2.*t4.*t5.*t7-offC1.*t2.*t3.*tpp4+offC2.*t2.*t5.*tpp4+offC2.*t3.*t4.*tpp5+offC1.*t4.*t5.*tpp5-offP1.*t2.*t3.*tpp4+offP2.*t2.*t5.*tpp4+offP2.*t3.*t4.*tpp5+offP1.*t4.*t5.*tpp5-t2.*t3.*tp1.*tp4.*2.0+t2.*t5.*tp2.*tp4.*2.0+t3.*t4.*tp2.*tp5.*2.0+t4.*t5.*tp1.*tp5.*2.0+t3.*t4.*t6.*x;
     */
    /* 'kin_xyzbc_tt_J2P_jt:48' et2 =
     * t3.*t4.*t7.*x-t2.*t3.*tpp4.*x+t4.*t5.*tpp5.*x-t4.*t5.*t6.*y-t4.*t5.*t7.*y+t2.*t5.*tpp4.*y+t3.*t4.*tpp5.*y+offC2.*t2.*t3.*tp4.*tp5.*2.0+offC1.*t2.*t5.*tp4.*tp5.*2.0+offP2.*t2.*t3.*tp4.*tp5.*2.0+offP1.*t2.*t5.*tp4.*tp5.*2.0+t2.*t5.*tp4.*tp5.*x.*2.0+t2.*t3.*tp4.*tp5.*y.*2.0;
     */
    /* 'kin_xyzbc_tt_J2P_jt:49' et3 =
     * -t2.*t3.*tpp2-t2.*t5.*tpp1+offC2.*t2.*t3.*t6+offC1.*t2.*t5.*t6+offC2.*t2.*t3.*t7+offC1.*t2.*t5.*t7+offP2.*t2.*t3.*t6+offP1.*t2.*t5.*t6+offP2.*t2.*t3.*t7+offP1.*t2.*t5.*t7-offC1.*t2.*t3.*tpp5+offC2.*t3.*t4.*tpp4+offC1.*t4.*t5.*tpp4+offC2.*t2.*t5.*tpp5-offP1.*t2.*t3.*tpp5+offP2.*t3.*t4.*tpp4+offP1.*t4.*t5.*tpp4+offP2.*t2.*t5.*tpp5-t2.*t3.*tp1.*tp5.*2.0+t3.*t4.*tp2.*tp4.*2.0+t2.*t5.*tp2.*tp5.*2.0+t4.*t5.*tp1.*tp4.*2.0+t2.*t5.*t6.*x+t2.*t5.*t7.*x-t2.*t3.*tpp5.*x+t4.*t5.*tpp4.*x+t2.*t3.*t6.*y+t2.*t3.*t7.*y+t3.*t4.*tpp4.*y+t2.*t5.*tpp5.*y+offC1.*t3.*t4.*tp4.*tp5.*2.0-offC2.*t4.*t5.*tp4.*tp5.*2.0+offP1.*t3.*t4.*tp4.*tp5.*2.0-offP2.*t4.*t5.*tp4.*tp5.*2.0+t3.*t4.*tp4.*tp5.*x.*2.0;
     */
    /* 'kin_xyzbc_tt_J2P_jt:50' et4 = t4.*t5.*tp4.*tp5.*y.*-2.0; */
    /* 'kin_xyzbc_tt_J2P_jt:51' et5 =
     * -t4.*tpp3+offB1.*t2.*t6+offB3.*t4.*t6+offC3.*t4.*t6+offP3.*t4.*t6+offB1.*t4.*tpp4-offB3.*t2.*tpp4-offC3.*t2.*tpp4-offP3.*t2.*tpp4-t2.*t3.*tpp1+t2.*t5.*tpp2-t2.*tp3.*tp4.*2.0+t4.*t6.*z-t2.*tpp4.*z+offC1.*t2.*t3.*t6+offC1.*t2.*t3.*t7-offC2.*t2.*t5.*t6-offC2.*t2.*t5.*t7+offP1.*t2.*t3.*t6+offP1.*t2.*t3.*t7-offP2.*t2.*t5.*t6-offP2.*t2.*t5.*t7+offC1.*t3.*t4.*tpp4+offC2.*t2.*t3.*tpp5+offC1.*t2.*t5.*tpp5-offC2.*t4.*t5.*tpp4+offP1.*t3.*t4.*tpp4+offP2.*t2.*t3.*tpp5+offP1.*t2.*t5.*tpp5-offP2.*t4.*t5.*tpp4+t2.*t3.*tp2.*tp5.*2.0+t3.*t4.*tp1.*tp4.*2.0+t2.*t5.*tp1.*tp5.*2.0-t4.*t5.*tp2.*tp4.*2.0+t2.*t3.*t6.*x+t2.*t3.*t7.*x;
     */
    /* 'kin_xyzbc_tt_J2P_jt:52' et6 =
     * t3.*t4.*tpp4.*x+t2.*t5.*tpp5.*x-t2.*t5.*t6.*y-t2.*t5.*t7.*y+t2.*t3.*tpp5.*y-t4.*t5.*tpp4.*y-offC2.*t3.*t4.*tp4.*tp5.*2.0-offC1.*t4.*t5.*tp4.*tp5.*2.0-offP2.*t3.*t4.*tp4.*tp5.*2.0-offP1.*t4.*t5.*tp4.*tp5.*2.0-t4.*t5.*tp4.*tp5.*x.*2.0-t3.*t4.*tp4.*tp5.*y.*2.0;
     */
    /* 'kin_xyzbc_tt_J2P_jt:53' et7 =
     * t3.*t4.*tpp2+t4.*t5.*tpp1-offC2.*t3.*t4.*t6-offC1.*t4.*t5.*t6-offC2.*t3.*t4.*t7-offC1.*t4.*t5.*t7-offP2.*t3.*t4.*t6-offP1.*t4.*t5.*t6-offP2.*t3.*t4.*t7-offP1.*t4.*t5.*t7+offC2.*t2.*t3.*tpp4+offC1.*t2.*t5.*tpp4+offC1.*t3.*t4.*tpp5-offC2.*t4.*t5.*tpp5+offP2.*t2.*t3.*tpp4+offP1.*t2.*t5.*tpp4+offP1.*t3.*t4.*tpp5-offP2.*t4.*t5.*tpp5+t2.*t3.*tp2.*tp4.*2.0+t2.*t5.*tp1.*tp4.*2.0+t3.*t4.*tp1.*tp5.*2.0-t4.*t5.*tp2.*tp5.*2.0-t4.*t5.*t6.*x-t4.*t5.*t7.*x+t2.*t5.*tpp4.*x+t3.*t4.*tpp5.*x-t3.*t4.*t6.*y-t3.*t4.*t7.*y+t2.*t3.*tpp4.*y-t4.*t5.*tpp5.*y+offC1.*t2.*t3.*tp4.*tp5.*2.0-offC2.*t2.*t5.*tp4.*tp5.*2.0;
     */
    /* 'kin_xyzbc_tt_J2P_jt:54' et8 =
     * offP1.*t2.*t3.*tp4.*tp5.*2.0-offP2.*t2.*t5.*tp4.*tp5.*2.0+t2.*t3.*tp4.*tp5.*x.*2.0-t2.*t5.*tp4.*tp5.*y.*2.0;
     */
    /* 'kin_xyzbc_tt_J2P_jt:55' mt1 =
     * [-t2.*t3.*t6-t2.*t3.*t7-t3.*t4.*tpp4-t2.*t5.*tpp5+t4.*t5.*tp4.*tp5.*2.0,-t5.*t7+t3.*tpp5,t3.*t4.*t6+t3.*t4.*t7-t2.*t3.*tpp4+t4.*t5.*tpp5+t2.*t5.*tp4.*tp5.*2.0,0.0,0.0,t2.*t5.*t6+t2.*t5.*t7-t2.*t3.*tpp5+t4.*t5.*tpp4+t3.*t4.*tp4.*tp5.*2.0,-t3.*t7-t5.*tpp5,-t4.*t5.*t6-t4.*t5.*t7+t2.*t5.*tpp4+t3.*t4.*tpp5+t2.*t3.*tp4.*tp5.*2.0,0.0,0.0,-t4.*t6+t2.*tpp4,0.0,-t2.*t6-t4.*tpp4,0.0,0.0,et1+et2,0.0,et5+et6,0.0,0.0,et3+et4];
     */
    /* 'kin_xyzbc_tt_J2P_jt:56' mt2 =
     * [t3.*tpp1-t5.*tpp2-offC1.*t3.*t7+offC2.*t5.*t7-offP1.*t3.*t7+offP2.*t5.*t7-offC2.*t3.*tpp5-offC1.*t5.*tpp5-offP2.*t3.*tpp5-offP1.*t5.*tpp5-t3.*tp2.*tp5.*2.0-t5.*tp1.*tp5.*2.0-t3.*t7.*x-t5.*tpp5.*x+t5.*t7.*y-t3.*tpp5.*y,et7+et8,0.0,0.0];
     */
    /* 'kin_xyzbc_tt_J2P_jt:57' J2P_jt = reshape([mt1,mt2],5,5); */
    t2_tmp = t3 * t4;
    b_t2_tmp = t2 * t3;
    c_t2_tmp = t4 * t5;
    d_t2_tmp = t2 * t5;
    e_t2_tmp = b_t2_tmp * t7;
    f_t2_tmp = t2_tmp * in3[3];
    g_t2_tmp = d_t2_tmp * in3[4];
    h_t2_tmp = c_t2_tmp * in2[3] * in2[4];
    i_t2_tmp = -t2 * t3;
    b_t2[0] = (((i_t2_tmp * t6 - e_t2_tmp) - f_t2_tmp) - g_t2_tmp) + h_t2_tmp * 2.0;
    j_t2_tmp = t3 * in3[4];
    b_t2[1] = -t5 * t7 + j_t2_tmp;
    k_t2_tmp = t2_tmp * t6;
    l_t2_tmp = t2_tmp * t7;
    m_t2_tmp = b_t2_tmp * in3[3];
    n_t2_tmp = c_t2_tmp * in3[4];
    o_t2_tmp = d_t2_tmp * in2[3] * in2[4];
    b_t2[2] = (((k_t2_tmp + l_t2_tmp) - m_t2_tmp) + n_t2_tmp) + o_t2_tmp * 2.0;
    b_t2[3] = 0.0;
    b_t2[4] = 0.0;
    p_t2_tmp = d_t2_tmp * t6;
    q_t2_tmp = d_t2_tmp * t7;
    r_t2_tmp = b_t2_tmp * in3[4];
    s_t2_tmp = c_t2_tmp * in3[3];
    t_t2_tmp = t2_tmp * in2[3] * in2[4];
    b_t2[5] = (((p_t2_tmp + q_t2_tmp) - r_t2_tmp) + s_t2_tmp) + t_t2_tmp * 2.0;
    u_t2_tmp = t5 * in3[4];
    b_t2[6] = -t3 * t7 - u_t2_tmp;
    v_t2_tmp = c_t2_tmp * t7;
    w_t2_tmp = d_t2_tmp * in3[3];
    x_t2_tmp = t2_tmp * in3[4];
    y_t2_tmp = b_t2_tmp * in2[3] * in2[4];
    b_t2[7] = (((-t4 * t5 * t6 - v_t2_tmp) + w_t2_tmp) + x_t2_tmp) + y_t2_tmp * 2.0;
    b_t2[8] = 0.0;
    b_t2[9] = 0.0;
    ab_t2_tmp = t2 * in3[3];
    b_t2[10] = -t4 * t6 + ab_t2_tmp;
    b_t2[11] = 0.0;
    bb_t2_tmp = t4 * in3[3];
    b_t2[12] = -t2 * t6 - bb_t2_tmp;
    b_t2[13] = 0.0;
    b_t2[14] = 0.0;
    t2_tmp_tmp = (&in4[0][0])[12] * t3;
    cb_t2_tmp = t2_tmp_tmp * t4;
    db_t2_tmp = (&in4[0][0])[13] * t4 * t5;
    b_t2_tmp_tmp = (&in4[0][0])[6] * t3;
    eb_t2_tmp = b_t2_tmp_tmp * t4;
    fb_t2_tmp = (&in4[0][0])[7] * t4 * t5;
    gb_t2_tmp = (&in4[0][0])[13] * t2;
    hb_t2_tmp = (&in4[0][0])[12] * t2;
    ib_t2_tmp = (&in4[0][0])[7] * t2;
    jb_t2_tmp = (&in4[0][0])[6] * t2;
    kb_t2_tmp = (&in4[0][0])[9] * t2;
    lb_t2_tmp = (&in4[0][0])[11] * t4;
    mb_t2_tmp = (&in4[0][0])[14] * t4;
    nb_t2_tmp = (&in4[0][0])[8] * t4;
    ob_t2_tmp = (&in4[0][0])[9] * t4;
    pb_t2_tmp = (&in4[0][0])[11] * t2;
    qb_t2_tmp = (&in4[0][0])[14] * t2;
    rb_t2_tmp = (&in4[0][0])[8] * t2;
    sb_t2_tmp = hb_t2_tmp * t3;
    tb_t2_tmp = gb_t2_tmp * t5;
    ub_t2_tmp = jb_t2_tmp * t3;
    vb_t2_tmp = ib_t2_tmp * t5;
    wb_t2_tmp = gb_t2_tmp * t3;
    xb_t2_tmp = hb_t2_tmp * t5;
    yb_t2_tmp = ib_t2_tmp * t3;
    ac_t2_tmp = jb_t2_tmp * t5;
    c_t2_tmp_tmp = (&in4[0][0])[13] * t3;
    bc_t2_tmp = c_t2_tmp_tmp * t4;
    cc_t2_tmp = (&in4[0][0])[12] * t4 * t5;
    d_t2_tmp_tmp = (&in4[0][0])[7] * t3;
    dc_t2_tmp = d_t2_tmp_tmp * t4;
    ec_t2_tmp = (&in4[0][0])[6] * t4 * t5;
    fc_t2_tmp = b_t2_tmp * in2[0];
    gc_t2_tmp = t2_tmp * in2[1];
    hc_t2_tmp = d_t2_tmp * in2[1];
    ic_t2_tmp = c_t2_tmp * in2[0];
    jc_t2_tmp = c_t2_tmp * t6;
    b_t2[15] = ((((((((((((((((((((((((((((((((((t2 * in3[2] + ob_t2_tmp * t6) - pb_t2_tmp * t6) -
                                               qb_t2_tmp * t6) -
                                              rb_t2_tmp * t6) -
                                             kb_t2_tmp * in3[3]) -
                                            lb_t2_tmp * in3[3]) -
                                           mb_t2_tmp * in3[3]) -
                                          nb_t2_tmp * in3[3]) -
                                         t2_tmp * in3[0]) +
                                        c_t2_tmp * in3[1]) -
                                       t4 * in2[2] * in2[3] * 2.0) -
                                      t2 * t6 * in1[2]) -
                                     bb_t2_tmp * in1[2]) +
                                    cb_t2_tmp * t6) +
                                   cb_t2_tmp * t7) -
                                  db_t2_tmp * t6) -
                                 db_t2_tmp * t7) +
                                eb_t2_tmp * t6) +
                               eb_t2_tmp * t7) -
                              fb_t2_tmp * t6) -
                             fb_t2_tmp * t7) -
                            sb_t2_tmp * in3[3]) +
                           tb_t2_tmp * in3[3]) +
                          bc_t2_tmp * in3[4]) +
                         cc_t2_tmp * in3[4]) -
                        ub_t2_tmp * in3[3]) +
                       vb_t2_tmp * in3[3]) +
                      dc_t2_tmp * in3[4]) +
                     ec_t2_tmp * in3[4]) -
                    fc_t2_tmp * in2[3] * 2.0) +
                   hc_t2_tmp * in2[3] * 2.0) +
                  gc_t2_tmp * in2[4] * 2.0) +
                 ic_t2_tmp * in2[4] * 2.0) +
                k_t2_tmp * in1[0]) +
               ((((((((((((l_t2_tmp * in1[0] - m_t2_tmp * in1[0]) + n_t2_tmp * in1[0]) -
                         jc_t2_tmp * in1[1]) -
                        v_t2_tmp * in1[1]) +
                       w_t2_tmp * in1[1]) +
                      x_t2_tmp * in1[1]) +
                     wb_t2_tmp * in2[3] * in2[4] * 2.0) +
                    xb_t2_tmp * in2[3] * in2[4] * 2.0) +
                   yb_t2_tmp * in2[3] * in2[4] * 2.0) +
                  ac_t2_tmp * in2[3] * in2[4] * 2.0) +
                 o_t2_tmp * in1[0] * 2.0) +
                y_t2_tmp * in1[1] * 2.0);
    b_t2[16] = 0.0;
    kc_t2_tmp = b_t2_tmp * t6;
    lc_t2_tmp = b_t2_tmp * in2[1];
    mc_t2_tmp = d_t2_tmp * in2[0];
    nc_t2_tmp = t2_tmp * in2[0];
    oc_t2_tmp = c_t2_tmp * in2[1];
    b_t2[17] = (((((((((((((((((((((((((((((((((((-t4 * in3[2] + kb_t2_tmp * t6) + lb_t2_tmp * t6) +
                                                mb_t2_tmp * t6) +
                                               nb_t2_tmp * t6) +
                                              ob_t2_tmp * in3[3]) -
                                             pb_t2_tmp * in3[3]) -
                                            qb_t2_tmp * in3[3]) -
                                           rb_t2_tmp * in3[3]) -
                                          b_t2_tmp * in3[0]) +
                                         d_t2_tmp * in3[1]) -
                                        t2 * in2[2] * in2[3] * 2.0) +
                                       t4 * t6 * in1[2]) -
                                      ab_t2_tmp * in1[2]) +
                                     sb_t2_tmp * t6) +
                                    sb_t2_tmp * t7) -
                                   tb_t2_tmp * t6) -
                                  tb_t2_tmp * t7) +
                                 ub_t2_tmp * t6) +
                                ub_t2_tmp * t7) -
                               vb_t2_tmp * t6) -
                              vb_t2_tmp * t7) +
                             cb_t2_tmp * in3[3]) +
                            wb_t2_tmp * in3[4]) +
                           xb_t2_tmp * in3[4]) -
                          db_t2_tmp * in3[3]) +
                         eb_t2_tmp * in3[3]) +
                        yb_t2_tmp * in3[4]) +
                       ac_t2_tmp * in3[4]) -
                      fb_t2_tmp * in3[3]) +
                     lc_t2_tmp * in2[4] * 2.0) +
                    nc_t2_tmp * in2[3] * 2.0) +
                   mc_t2_tmp * in2[4] * 2.0) -
                  oc_t2_tmp * in2[3] * 2.0) +
                 kc_t2_tmp * in1[0]) +
                e_t2_tmp * in1[0]) +
               (((((((((((f_t2_tmp * in1[0] + g_t2_tmp * in1[0]) - p_t2_tmp * in1[1]) -
                        q_t2_tmp * in1[1]) +
                       r_t2_tmp * in1[1]) -
                      s_t2_tmp * in1[1]) -
                     bc_t2_tmp * in2[3] * in2[4] * 2.0) -
                    cc_t2_tmp * in2[3] * in2[4] * 2.0) -
                   dc_t2_tmp * in2[3] * in2[4] * 2.0) -
                  ec_t2_tmp * in2[3] * in2[4] * 2.0) -
                 h_t2_tmp * in1[0] * 2.0) -
                t_t2_tmp * in1[1] * 2.0);
    b_t2[18] = 0.0;
    b_t2[19] = 0.0;
    b_t2[20] =
        ((((((((((((((((((((((((((((((((((i_t2_tmp * in3[1] - d_t2_tmp * in3[0]) + wb_t2_tmp * t6) +
                                        xb_t2_tmp * t6) +
                                       wb_t2_tmp * t7) +
                                      xb_t2_tmp * t7) +
                                     yb_t2_tmp * t6) +
                                    ac_t2_tmp * t6) +
                                   yb_t2_tmp * t7) +
                                  ac_t2_tmp * t7) -
                                 sb_t2_tmp * in3[4]) +
                                bc_t2_tmp * in3[3]) +
                               cc_t2_tmp * in3[3]) +
                              tb_t2_tmp * in3[4]) -
                             ub_t2_tmp * in3[4]) +
                            dc_t2_tmp * in3[3]) +
                           ec_t2_tmp * in3[3]) +
                          vb_t2_tmp * in3[4]) -
                         fc_t2_tmp * in2[4] * 2.0) +
                        gc_t2_tmp * in2[3] * 2.0) +
                       hc_t2_tmp * in2[4] * 2.0) +
                      ic_t2_tmp * in2[3] * 2.0) +
                     p_t2_tmp * in1[0]) +
                    q_t2_tmp * in1[0]) -
                   r_t2_tmp * in1[0]) +
                  s_t2_tmp * in1[0]) +
                 kc_t2_tmp * in1[1]) +
                e_t2_tmp * in1[1]) +
               f_t2_tmp * in1[1]) +
              g_t2_tmp * in1[1]) +
             cb_t2_tmp * in2[3] * in2[4] * 2.0) -
            db_t2_tmp * in2[3] * in2[4] * 2.0) +
           eb_t2_tmp * in2[3] * in2[4] * 2.0) -
          fb_t2_tmp * in2[3] * in2[4] * 2.0) +
         t_t2_tmp * in1[0] * 2.0) +
        h_t2_tmp * in1[1] * -2.0;
    b_t2[21] =
        ((((((((((((((t3 * in3[0] - t5 * in3[1]) - t2_tmp_tmp * t7) + (&in4[0][0])[13] * t5 * t7) -
                   b_t2_tmp_tmp * t7) +
                  (&in4[0][0])[7] * t5 * t7) -
                 c_t2_tmp_tmp * in3[4]) -
                (&in4[0][0])[12] * t5 * in3[4]) -
               d_t2_tmp_tmp * in3[4]) -
              (&in4[0][0])[6] * t5 * in3[4]) -
             t3 * in2[1] * in2[4] * 2.0) -
            t5 * in2[0] * in2[4] * 2.0) -
           t3 * t7 * in1[0]) -
          u_t2_tmp * in1[0]) +
         t5 * t7 * in1[1]) -
        j_t2_tmp * in1[1];
    b_t2[22] =
        (((((((((((((((((((((((((((((((t2_tmp * in3[1] + c_t2_tmp * in3[0]) - bc_t2_tmp * t6) -
                                     cc_t2_tmp * t6) -
                                    bc_t2_tmp * t7) -
                                   cc_t2_tmp * t7) -
                                  dc_t2_tmp * t6) -
                                 ec_t2_tmp * t6) -
                                dc_t2_tmp * t7) -
                               ec_t2_tmp * t7) +
                              wb_t2_tmp * in3[3]) +
                             xb_t2_tmp * in3[3]) +
                            cb_t2_tmp * in3[4]) -
                           db_t2_tmp * in3[4]) +
                          yb_t2_tmp * in3[3]) +
                         ac_t2_tmp * in3[3]) +
                        eb_t2_tmp * in3[4]) -
                       fb_t2_tmp * in3[4]) +
                      lc_t2_tmp * in2[3] * 2.0) +
                     mc_t2_tmp * in2[3] * 2.0) +
                    nc_t2_tmp * in2[4] * 2.0) -
                   oc_t2_tmp * in2[4] * 2.0) -
                  jc_t2_tmp * in1[0]) -
                 v_t2_tmp * in1[0]) +
                w_t2_tmp * in1[0]) +
               x_t2_tmp * in1[0]) -
              k_t2_tmp * in1[1]) -
             l_t2_tmp * in1[1]) +
            m_t2_tmp * in1[1]) -
           n_t2_tmp * in1[1]) +
          sb_t2_tmp * in2[3] * in2[4] * 2.0) -
         tb_t2_tmp * in2[3] * in2[4] * 2.0) +
        (((ub_t2_tmp * in2[3] * in2[4] * 2.0 - vb_t2_tmp * in2[3] * in2[4] * 2.0) +
          y_t2_tmp * in1[0] * 2.0) -
         o_t2_tmp * in1[1] * 2.0);
    b_t2[23] = 0.0;
    b_t2[24] = 0.0;
    for (i = 0; i < 5; i++) {
        for (i1 = 0; i1 < 5; i1++) {
            J2P_jt[i][i1] = b_t2[i1 + 5 * i];
        }
    }
}

/*
 * function J2P_tj = kin_xyzbc_tt_J2P_tj(in1,in2,in3,in4)
 *
 * kin_xyzbc_tt_J2P_tj
 *     J2P_tj = kin_xyzbc_tt_J2P_tj(IN1,IN2,IN3,IN4)
 *
 * Arguments    : const double in1[5]
 *                const double in2[5]
 *                const double in3[5]
 *                double in4[5][3]
 *                double J2P_tj[5][5]
 * Return Type  : void
 */
void kin_xyzbc_tt_J2P_tj(const double in1[5], const double in2[5], const double in3[5],
                         double in4[5][3], double J2P_tj[5][5])
{
    double b_in2[25];
    double b_in2_tmp;
    double b_t58_tmp;
    double c_in2_tmp;
    double d_in2_tmp;
    double e_in2_tmp;
    double f_in2_tmp;
    double g_in2_tmp;
    double in2_tmp;
    double t15;
    double t15_tmp;
    double t17;
    double t17_tmp;
    double t19;
    double t2;
    double t22;
    double t23;
    double t24;
    double t28;
    double t29;
    double t3;
    double t36;
    double t37;
    double t38;
    double t4;
    double t41;
    double t42;
    double t42_tmp;
    double t45;
    double t45_tmp;
    double t5;
    double t50;
    double t50_tmp;
    double t52;
    double t53;
    double t57;
    double t58;
    double t58_tmp;
    double t59;
    double t6;
    double t61;
    double t62;
    double t63;
    double t7;
    double t70;
    double t71;
    double t72;
    double t72_tmp;
    double t73;
    double t73_tmp;
    int i;
    int i1;
    /*     This function was generated by the Symbolic Math Toolbox version 9.1. */
    /*     07-Nov-2023 14:54:38 */
    /* Jacobian second derivative ( Forward Kinematics ) :  */
    /* INPUTS :  */
    /* 	r_j    (5x1) : pose vector( joint space ) */
    /* 	v_j    (5x1) : speed vector( joint space ) */
    /* 	a_j    (5x1) : acceleration vector( joint space ) */
    /* 	j_j    (5x1) : jerk vector( joint space ) */
    /* 	p      (3x5) : parameters */
    /* OUTPUTS :  */
    /* 	M      (5x5) : resulting matrix */
    /* 'kin_xyzbc_tt_J2P_tj:18' b = in1(4,:); */
    /* 'kin_xyzbc_tt_J2P_tj:19' c = in1(5,:); */
    /* 'kin_xyzbc_tt_J2P_tj:20' jp1 = in2(1,:); */
    /* 'kin_xyzbc_tt_J2P_tj:21' jp2 = in2(2,:); */
    /* 'kin_xyzbc_tt_J2P_tj:22' jp3 = in2(3,:); */
    /* 'kin_xyzbc_tt_J2P_tj:23' jp4 = in2(4,:); */
    /* 'kin_xyzbc_tt_J2P_tj:24' jp5 = in2(5,:); */
    /* 'kin_xyzbc_tt_J2P_tj:25' jpp1 = in3(1,:); */
    /* 'kin_xyzbc_tt_J2P_tj:26' jpp2 = in3(2,:); */
    /* 'kin_xyzbc_tt_J2P_tj:27' jpp3 = in3(3,:); */
    /* 'kin_xyzbc_tt_J2P_tj:28' jpp4 = in3(4,:); */
    /* 'kin_xyzbc_tt_J2P_tj:29' jpp5 = in3(5,:); */
    /* 'kin_xyzbc_tt_J2P_tj:30' offB1 = in4(10); */
    /* 'kin_xyzbc_tt_J2P_tj:31' offB2 = in4(11); */
    /* 'kin_xyzbc_tt_J2P_tj:32' offC1 = in4(13); */
    /* 'kin_xyzbc_tt_J2P_tj:33' offB3 = in4(12); */
    /* 'kin_xyzbc_tt_J2P_tj:34' offC2 = in4(14); */
    /* 'kin_xyzbc_tt_J2P_tj:35' offC3 = in4(15); */
    /* 'kin_xyzbc_tt_J2P_tj:36' offM1 = in4(1); */
    /* 'kin_xyzbc_tt_J2P_tj:37' offM2 = in4(2); */
    /* 'kin_xyzbc_tt_J2P_tj:38' offM3 = in4(3); */
    /* 'kin_xyzbc_tt_J2P_tj:39' offT1 = in4(4); */
    /* 'kin_xyzbc_tt_J2P_tj:40' offT2 = in4(5); */
    /* 'kin_xyzbc_tt_J2P_tj:41' offT3 = in4(6); */
    /* 'kin_xyzbc_tt_J2P_tj:42' x = in1(1,:); */
    /* 'kin_xyzbc_tt_J2P_tj:43' y = in1(2,:); */
    /* 'kin_xyzbc_tt_J2P_tj:44' z = in1(3,:); */
    /* 'kin_xyzbc_tt_J2P_tj:45' t2 = cos(b); */
    t2 = cos(in1[3]);
    /* 'kin_xyzbc_tt_J2P_tj:46' t3 = cos(c); */
    t3 = cos(in1[4]);
    /* 'kin_xyzbc_tt_J2P_tj:47' t4 = sin(b); */
    t4 = sin(in1[3]);
    /* 'kin_xyzbc_tt_J2P_tj:48' t5 = sin(c); */
    t5 = sin(in1[4]);
    /* 'kin_xyzbc_tt_J2P_tj:49' t6 = jp4.^2; */
    t6 = in2[3] * in2[3];
    /* 'kin_xyzbc_tt_J2P_tj:50' t7 = jp5.^2; */
    t7 = in2[4] * in2[4];
    /* 'kin_xyzbc_tt_J2P_tj:51' t12 = -offM1; */
    /* 'kin_xyzbc_tt_J2P_tj:52' t13 = -offM2; */
    /* 'kin_xyzbc_tt_J2P_tj:53' t14 = -offM3; */
    /* 'kin_xyzbc_tt_J2P_tj:54' t8 = offB1.*t3; */
    /* 'kin_xyzbc_tt_J2P_tj:55' t9 = offB2.*t3; */
    /* 'kin_xyzbc_tt_J2P_tj:56' t10 = offB1.*t5; */
    /* 'kin_xyzbc_tt_J2P_tj:57' t11 = offB2.*t5; */
    /* 'kin_xyzbc_tt_J2P_tj:58' t15 = jp1.*t2.*t3; */
    t15_tmp = in2[0] * t2;
    t15 = t15_tmp * t3;
    /* 'kin_xyzbc_tt_J2P_tj:59' t16 = jp3.*t2.*t3; */
    /* 'kin_xyzbc_tt_J2P_tj:60' t17 = jp4.*t2.*t3; */
    t17_tmp = in2[3] * t2;
    t17 = t17_tmp * t3;
    /* 'kin_xyzbc_tt_J2P_tj:61' t18 = jp5.*t2.*t3; */
    /* 'kin_xyzbc_tt_J2P_tj:62' t19 = jp1.*t2.*t5; */
    t19 = t15_tmp * t5;
    /* 'kin_xyzbc_tt_J2P_tj:63' t20 = jp1.*t3.*t4; */
    /* 'kin_xyzbc_tt_J2P_tj:64' t21 = jp3.*t2.*t5; */
    /* 'kin_xyzbc_tt_J2P_tj:65' t22 = jp3.*t3.*t4; */
    t22 = in2[2] * t3 * t4;
    /* 'kin_xyzbc_tt_J2P_tj:66' t23 = jp4.*t2.*t5; */
    t23 = t17_tmp * t5;
    /* 'kin_xyzbc_tt_J2P_tj:67' t24 = jp4.*t3.*t4; */
    t24 = in2[3] * t3 * t4;
    /* 'kin_xyzbc_tt_J2P_tj:68' t25 = jp5.*t2.*t5; */
    /* 'kin_xyzbc_tt_J2P_tj:69' t26 = jp5.*t3.*t4; */
    /* 'kin_xyzbc_tt_J2P_tj:70' t27 = jp1.*t4.*t5; */
    /* 'kin_xyzbc_tt_J2P_tj:71' t28 = jp3.*t4.*t5; */
    t28 = in2[2] * t4 * t5;
    /* 'kin_xyzbc_tt_J2P_tj:72' t29 = jp4.*t4.*t5; */
    t29 = in2[3] * t4 * t5;
    /* 'kin_xyzbc_tt_J2P_tj:73' t30 = jp5.*t4.*t5; */
    /* 'kin_xyzbc_tt_J2P_tj:74' t36 = offB1+offC1+offT1+t12+x; */
    t36 = ((((&in4[0][0])[9] + (&in4[0][0])[12]) + (&in4[0][0])[3]) + -(&in4[0][0])[0]) + in1[0];
    /* 'kin_xyzbc_tt_J2P_tj:75' t37 = offB2+offC2+offT2+t13+y; */
    t37 = ((((&in4[0][0])[10] + (&in4[0][0])[13]) + (&in4[0][0])[4]) + -(&in4[0][0])[1]) + in1[1];
    /* 'kin_xyzbc_tt_J2P_tj:76' t38 = offB3+offC3+offT3+t14+z; */
    t38 = ((((&in4[0][0])[11] + (&in4[0][0])[14]) + (&in4[0][0])[5]) + -(&in4[0][0])[2]) + in1[2];
    /* 'kin_xyzbc_tt_J2P_tj:77' t31 = -t9; */
    /* 'kin_xyzbc_tt_J2P_tj:78' t32 = -t19; */
    /* 'kin_xyzbc_tt_J2P_tj:79' t33 = -t22; */
    /* 'kin_xyzbc_tt_J2P_tj:80' t34 = -t29; */
    /* 'kin_xyzbc_tt_J2P_tj:81' t35 = -t30; */
    /* 'kin_xyzbc_tt_J2P_tj:82' t39 = t3.*t37; */
    /* 'kin_xyzbc_tt_J2P_tj:83' t40 = t5.*t37; */
    /* 'kin_xyzbc_tt_J2P_tj:84' t41 = t23+t26; */
    t41 = t23 + in2[4] * t3 * t4;
    /* 'kin_xyzbc_tt_J2P_tj:85' t42 = t24+t25; */
    t42_tmp = in2[4] * t2;
    t42 = t24 + t42_tmp * t5;
    /* 'kin_xyzbc_tt_J2P_tj:86' t43 = t4.*t5.*t38; */
    /* 'kin_xyzbc_tt_J2P_tj:87' t45 = t2.*t3.*t36; */
    t45_tmp = t2 * t3;
    t45 = t45_tmp * t36;
    /* 'kin_xyzbc_tt_J2P_tj:88' t46 = t2.*t3.*t38; */
    /* 'kin_xyzbc_tt_J2P_tj:89' t47 = t2.*t5.*t36; */
    /* 'kin_xyzbc_tt_J2P_tj:90' t48 = t3.*t4.*t36; */
    /* 'kin_xyzbc_tt_J2P_tj:91' t49 = t2.*t5.*t38; */
    /* 'kin_xyzbc_tt_J2P_tj:92' t50 = t3.*t4.*t38; */
    t50_tmp = t3 * t4;
    t50 = t50_tmp * t38;
    /* 'kin_xyzbc_tt_J2P_tj:93' t51 = t4.*t5.*t36; */
    /* 'kin_xyzbc_tt_J2P_tj:94' t44 = -t40; */
    /* 'kin_xyzbc_tt_J2P_tj:95' t52 = t17+t35; */
    t52 = t17 + -(in2[4] * t4 * t5);
    /* 'kin_xyzbc_tt_J2P_tj:96' t53 = t18+t34; */
    t53 = t42_tmp * t3 + -t29;
    /* 'kin_xyzbc_tt_J2P_tj:97' t54 = -t45; */
    /* 'kin_xyzbc_tt_J2P_tj:98' t55 = -t47; */
    /* 'kin_xyzbc_tt_J2P_tj:99' t56 = -t50; */
    /* 'kin_xyzbc_tt_J2P_tj:100' t57 = t46+t48; */
    t57 = t45_tmp * t38 + t50_tmp * t36;
    /* 'kin_xyzbc_tt_J2P_tj:101' t58 = t49+t51; */
    t58_tmp = t4 * t5;
    b_t58_tmp = t2 * t5;
    t58 = b_t58_tmp * t38 + t58_tmp * t36;
    /* 'kin_xyzbc_tt_J2P_tj:102' t59 = jp4.*t58; */
    t59 = in2[3] * t58;
    /* 'kin_xyzbc_tt_J2P_tj:103' t60 = jp5.*t58; */
    /* 'kin_xyzbc_tt_J2P_tj:104' t61 = t45+t56; */
    t61 = t45 + -t50;
    /* 'kin_xyzbc_tt_J2P_tj:105' t62 = t43+t55; */
    t62 = t58_tmp * t38 + -(b_t58_tmp * t36);
    /* 'kin_xyzbc_tt_J2P_tj:106' t63 = jp4.*t57; */
    t63 = in2[3] * t57;
    /* 'kin_xyzbc_tt_J2P_tj:107' t64 = jp5.*t57; */
    /* 'kin_xyzbc_tt_J2P_tj:108' t70 = t8+t11+t44+t50+t54; */
    t70 = ((((&in4[0][0])[9] * t3 + (&in4[0][0])[10] * t5) + -(t5 * t37)) + t50) + -t45;
    /* 'kin_xyzbc_tt_J2P_tj:109' t65 = jp4.*t62; */
    /* 'kin_xyzbc_tt_J2P_tj:110' t66 = -t60; */
    /* 'kin_xyzbc_tt_J2P_tj:111' t67 = jp4.*t61; */
    /* 'kin_xyzbc_tt_J2P_tj:112' t68 = -t63; */
    /* 'kin_xyzbc_tt_J2P_tj:113' t71 = t10+t31+t39+t62; */
    t71 = (((&in4[0][0])[9] * t5 + -((&in4[0][0])[10] * t3)) + t3 * t37) + t62;
    /* 'kin_xyzbc_tt_J2P_tj:114' t69 = -t65; */
    /* 'kin_xyzbc_tt_J2P_tj:115' t72 = t16+t20+t66+t67; */
    t72_tmp = in2[2] * t2;
    t72 = ((t72_tmp * t3 + in2[0] * t3 * t4) + -(in2[4] * t58)) + in2[3] * t61;
    /* 'kin_xyzbc_tt_J2P_tj:116' t73 = t21+t27+t64+t69; */
    t73_tmp = in2[0] * t4;
    t73 = ((t72_tmp * t5 + t73_tmp * t5) + in2[4] * t57) + -(in2[3] * t62);
    /* 'kin_xyzbc_tt_J2P_tj:117' mt1 =
     * [jp5.*t29.*2.0-jpp4.*t3.*t4-jpp5.*t2.*t5-t2.*t3.*t6-t2.*t3.*t7,jp5.*t24.*2.0-jpp5.*t2.*t3+jpp4.*t4.*t5+t2.*t5.*t6+t2.*t5.*t7,jpp4.*t2-t4.*t6,0.0,0.0,jpp5.*t3-t5.*t7,-jpp5.*t5-t3.*t7,0.0,0.0,0.0,jp5.*t23.*2.0-jpp4.*t2.*t3+jpp5.*t4.*t5+t3.*t4.*t6+t3.*t4.*t7,jp5.*t17.*2.0+jpp4.*t2.*t5+jpp5.*t3.*t4-t4.*t5.*t6-t4.*t5.*t7,-jpp4.*t4-t2.*t6,0.0,0.0,-jp4.*(t15-t22+t68+jp5.*t62)+jp3.*t42-jp1.*t52+jp5.*t73+jpp5.*t58-jpp4.*t61-jpp1.*t3.*t4-jpp3.*t2.*t3];
     */
    /* 'kin_xyzbc_tt_J2P_tj:118' mt2 =
     * [jp1.*t41+jp3.*t53+jp5.*t72+jpp5.*t57-jpp4.*t62+jp4.*(t19-t28-t59+jp5.*t61)+jpp1.*t4.*t5+jpp3.*t2.*t5,jpp1.*t2-jpp3.*t4-jp4.*(jp1.*t4+jp3.*t2+jp4.*(t2.*t36-t4.*t38))-jpp4.*(t2.*t38+t4.*t36)-jp1.*jp4.*t4-jp3.*jp4.*t2,0.0,0.0,-jp5.*(t15+t33+t68+jp2.*t5+jp5.*t71)+jp3.*t41-jp1.*t53+jp4.*t73+jpp2.*t3+jpp4.*t58+jpp5.*t70-jp2.*jp5.*t5-jpp1.*t2.*t5+jpp3.*t4.*t5];
     */
    /* 'kin_xyzbc_tt_J2P_tj:119' mt3 =
     * [-jp5.*(t28+t32+t59+jp2.*t3+jp5.*t70)+jp1.*t42+jp3.*t52+jp4.*t72-jpp2.*t5+jpp4.*t57-jpp5.*t71-jp2.*jp5.*t3-jpp1.*t2.*t3+jpp3.*t3.*t4,0.0,0.0,0.0];
     */
    /* 'kin_xyzbc_tt_J2P_tj:120' J2P_tj = reshape([mt1,mt2,mt3],5,5); */
    in2_tmp = in3[4] * t2;
    b_in2[0] =
        (((in2[4] * t29 * 2.0 - in3[3] * t3 * t4) - in2_tmp * t5) - t45_tmp * t6) - t45_tmp * t7;
    b_in2[1] = (((in2[4] * t24 * 2.0 - in2_tmp * t3) + in3[3] * t4 * t5) + b_t58_tmp * t6) +
               b_t58_tmp * t7;
    b_in2_tmp = in3[3] * t2;
    b_in2[2] = b_in2_tmp - t4 * t6;
    b_in2[3] = 0.0;
    b_in2[4] = 0.0;
    c_in2_tmp = in3[4] * t3;
    b_in2[5] = c_in2_tmp - t5 * t7;
    b_in2[6] = -in3[4] * t5 - t3 * t7;
    b_in2[7] = 0.0;
    b_in2[8] = 0.0;
    b_in2[9] = 0.0;
    b_in2[10] =
        (((in2[4] * t23 * 2.0 - b_in2_tmp * t3) + in3[4] * t4 * t5) + t50_tmp * t6) + t50_tmp * t7;
    b_in2[11] =
        (((in2[4] * t17 * 2.0 + b_in2_tmp * t5) + c_in2_tmp * t4) - t58_tmp * t6) - t58_tmp * t7;
    b_in2[12] = -in3[3] * t4 - t2 * t6;
    b_in2[13] = 0.0;
    b_in2[14] = 0.0;
    d_in2_tmp = in3[2] * t2;
    b_in2[15] =
        ((((((-in2[3] * (((t15 - t22) + -t63) + in2[4] * t62) + in2[2] * t42) - in2[0] * t52) +
            in2[4] * t73) +
           in3[4] * t58) -
          in3[3] * t61) -
         in3[0] * t3 * t4) -
        d_in2_tmp * t3;
    b_in2[16] = ((((((in2[0] * t41 + in2[2] * t53) + in2[4] * t72) + in3[4] * t57) - in3[3] * t62) +
                  in2[3] * (((t19 - t28) - t59) + in2[4] * t61)) +
                 in3[0] * t4 * t5) +
                d_in2_tmp * t5;
    e_in2_tmp = in3[0] * t2;
    f_in2_tmp = in3[2] * t4;
    b_in2[17] = ((((e_in2_tmp - f_in2_tmp) -
                   in2[3] * ((t73_tmp + t72_tmp) + in2[3] * (t2 * t36 - t4 * t38))) -
                  in3[3] * (t2 * t38 + t4 * t36)) -
                 in2[0] * in2[3] * t4) -
                in2[2] * in2[3] * t2;
    b_in2[18] = 0.0;
    b_in2[19] = 0.0;
    g_in2_tmp = in2[1] * in2[4];
    b_in2[20] =
        ((((((((-in2[4] * ((((t15 + -t22) + -t63) + in2[1] * t5) + in2[4] * t71) + in2[2] * t41) -
               in2[0] * t53) +
              in2[3] * t73) +
             in3[1] * t3) +
            in3[3] * t58) +
           in3[4] * t70) -
          g_in2_tmp * t5) -
         e_in2_tmp * t5) +
        f_in2_tmp * t5;
    b_in2[21] =
        ((((((((-in2[4] * ((((t28 + -t19) + t59) + in2[1] * t3) + in2[4] * t70) + in2[0] * t42) +
               in2[2] * t52) +
              in2[3] * t72) -
             in3[1] * t5) +
            in3[3] * t57) -
           in3[4] * t71) -
          g_in2_tmp * t3) -
         e_in2_tmp * t3) +
        in3[2] * t3 * t4;
    b_in2[22] = 0.0;
    b_in2[23] = 0.0;
    b_in2[24] = 0.0;
    for (i = 0; i < 5; i++) {
        for (i1 = 0; i1 < 5; i1++) {
            J2P_tj[i][i1] = b_in2[i1 + 5 * i];
        }
    }
}

/*
 * function JP_jt = kin_xyzbc_tt_JP_jt(in1,in2,in3)
 *
 * kin_xyzbc_tt_JP_jt
 *     JP_jt = kin_xyzbc_tt_JP_jt(IN1,IN2,IN3)
 *
 * Arguments    : const double in1[5]
 *                const double in2[5]
 *                double in3[5][3]
 *                double JP_jt[5][5]
 * Return Type  : void
 */
void kin_xyzbc_tt_JP_jt(const double in1[5], const double in2[5], double in3[5][3],
                        double JP_jt[5][5])
{
    double b_t3[25];
    double b_t3_tmp;
    double t12;
    double t13_tmp;
    double t16;
    double t17_tmp;
    double t2;
    double t20;
    double t20_tmp;
    double t21_tmp;
    double t24;
    double t24_tmp;
    double t27;
    double t28;
    double t28_tmp;
    double t3;
    double t3_tmp;
    double t4;
    double t5;
    double t6;
    double t7;
    double t8;
    double t9_tmp;
    int i;
    int i1;
    /*     This function was generated by the Symbolic Math Toolbox version 9.1. */
    /*     07-Nov-2023 14:54:35 */
    /* Jacobian first derivative ( Inverse Kinematics ) :  */
    /* INPUTS :  */
    /* 	r_t    (5x1) : pose vector ( piece frame ) */
    /* 	v_t    (5x1) : speed vector ( piece frame ) */
    /* 	a_t    (5x1) : acceleration vector( piece frame ) */
    /* 	p      (3x5) : parameters */
    /* OUTPUTS :  */
    /* 	M      (5x5) : resulting matrix */
    /* 'kin_xyzbc_tt_JP_jt:17' b = in1(4,:); */
    /* 'kin_xyzbc_tt_JP_jt:18' c = in1(5,:); */
    /* 'kin_xyzbc_tt_JP_jt:19' offB1 = in3(10); */
    /* 'kin_xyzbc_tt_JP_jt:20' offC1 = in3(13); */
    /* 'kin_xyzbc_tt_JP_jt:21' offB3 = in3(12); */
    /* 'kin_xyzbc_tt_JP_jt:22' offC2 = in3(14); */
    /* 'kin_xyzbc_tt_JP_jt:23' offC3 = in3(15); */
    /* 'kin_xyzbc_tt_JP_jt:24' offP1 = in3(7); */
    /* 'kin_xyzbc_tt_JP_jt:25' offP2 = in3(8); */
    /* 'kin_xyzbc_tt_JP_jt:26' offP3 = in3(9); */
    /* 'kin_xyzbc_tt_JP_jt:27' tp1 = in2(1,:); */
    /* 'kin_xyzbc_tt_JP_jt:28' tp2 = in2(2,:); */
    /* 'kin_xyzbc_tt_JP_jt:29' tp3 = in2(3,:); */
    /* 'kin_xyzbc_tt_JP_jt:30' tp4 = in2(4,:); */
    /* 'kin_xyzbc_tt_JP_jt:31' tp5 = in2(5,:); */
    /* 'kin_xyzbc_tt_JP_jt:32' x = in1(1,:); */
    /* 'kin_xyzbc_tt_JP_jt:33' y = in1(2,:); */
    /* 'kin_xyzbc_tt_JP_jt:34' z = in1(3,:); */
    /* 'kin_xyzbc_tt_JP_jt:35' t2 = cos(b); */
    t2 = cos(in1[3]);
    /* 'kin_xyzbc_tt_JP_jt:36' t3 = cos(c); */
    t3 = cos(in1[4]);
    /* 'kin_xyzbc_tt_JP_jt:37' t4 = sin(b); */
    t4 = sin(in1[3]);
    /* 'kin_xyzbc_tt_JP_jt:38' t5 = sin(c); */
    t5 = sin(in1[4]);
    /* 'kin_xyzbc_tt_JP_jt:39' t6 = offP1+x; */
    t6 = in1[0] + (&in3[0][0])[6];
    /* 'kin_xyzbc_tt_JP_jt:40' t7 = offP2+y; */
    t7 = in1[1] + (&in3[0][0])[7];
    /* 'kin_xyzbc_tt_JP_jt:41' t8 = offP3+z; */
    t8 = in1[2] + (&in3[0][0])[8];
    /* 'kin_xyzbc_tt_JP_jt:42' t9 = offC1.*t2.*t3; */
    t9_tmp = (&in3[0][0])[12] * t2;
    /* 'kin_xyzbc_tt_JP_jt:43' t10 = offC2.*t2.*t3; */
    /* 'kin_xyzbc_tt_JP_jt:44' t11 = offC1.*t2.*t5; */
    /* 'kin_xyzbc_tt_JP_jt:45' t12 = offC1.*t3.*t4; */
    t12 = (&in3[0][0])[12] * t3 * t4;
    /* 'kin_xyzbc_tt_JP_jt:46' t13 = offC2.*t2.*t5; */
    t13_tmp = (&in3[0][0])[13] * t2;
    /* 'kin_xyzbc_tt_JP_jt:47' t14 = offC2.*t3.*t4; */
    /* 'kin_xyzbc_tt_JP_jt:48' t15 = offC1.*t4.*t5; */
    /* 'kin_xyzbc_tt_JP_jt:49' t16 = offC2.*t4.*t5; */
    t16 = (&in3[0][0])[13] * t4 * t5;
    /* 'kin_xyzbc_tt_JP_jt:50' t17 = t2.*t3.*t6; */
    t17_tmp = t2 * t3;
    /* 'kin_xyzbc_tt_JP_jt:51' t18 = t2.*t3.*t7; */
    /* 'kin_xyzbc_tt_JP_jt:52' t19 = t2.*t5.*t6; */
    /* 'kin_xyzbc_tt_JP_jt:53' t20 = t3.*t4.*t6; */
    t20_tmp = t3 * t4;
    t20 = t20_tmp * t6;
    /* 'kin_xyzbc_tt_JP_jt:54' t21 = t2.*t5.*t7; */
    t21_tmp = t2 * t5;
    /* 'kin_xyzbc_tt_JP_jt:55' t22 = t3.*t4.*t7; */
    /* 'kin_xyzbc_tt_JP_jt:56' t23 = t4.*t5.*t6; */
    /* 'kin_xyzbc_tt_JP_jt:57' t24 = t4.*t5.*t7; */
    t24_tmp = t4 * t5;
    t24 = t24_tmp * t7;
    /* 'kin_xyzbc_tt_JP_jt:58' t25 = -t13; */
    /* 'kin_xyzbc_tt_JP_jt:59' t26 = -t21; */
    /* 'kin_xyzbc_tt_JP_jt:60' t27 = t10+t11+t18+t19; */
    t27 = ((t13_tmp * t3 + t9_tmp * t5) + t17_tmp * t7) + t21_tmp * t6;
    /* 'kin_xyzbc_tt_JP_jt:61' t28 = t14+t15+t22+t23; */
    t28_tmp = (&in3[0][0])[13] * t3;
    t28 = ((t28_tmp * t4 + (&in3[0][0])[12] * t4 * t5) + t20_tmp * t7) + t24_tmp * t6;
    /* 'kin_xyzbc_tt_JP_jt:62' mt1 =
     * [-t3.*t4.*tp4-t2.*t5.*tp5,t3.*tp5,-t2.*t3.*tp4+t4.*t5.*tp5,0.0,0.0,-t2.*t3.*tp5+t4.*t5.*tp4,-t5.*tp5,t2.*t5.*tp4+t3.*t4.*tp5,0.0,0.0,t2.*tp4,0.0,-t4.*tp4,0.0,0.0,-tp4.*(t9+t17+t25+t26+offB1.*t2+offB3.*t4+offC3.*t4+t4.*t8)+t2.*tp3+t28.*tp5-t3.*t4.*tp1+t4.*t5.*tp2,0.0,-t4.*tp3+t27.*tp5-tp4.*(-t12+t16-t20+t24-offB1.*t4+offB3.*t2+offC3.*t2+t2.*t8)-t2.*t3.*tp1+t2.*t5.*tp2,0.0,0.0,-tp5.*(t9+t17+t25+t26)+t28.*tp4-t2.*t3.*tp2-t2.*t5.*tp1];
     */
    /* 'kin_xyzbc_tt_JP_jt:63' mt2 =
     * [-tp5.*(offC2.*t3+offC1.*t5+t3.*t7+t5.*t6)+t3.*tp1-t5.*tp2,t27.*tp4+tp5.*(t12-t16+t20-t24)+t3.*t4.*tp2+t4.*t5.*tp1,0.0,0.0];
     */
    /* 'kin_xyzbc_tt_JP_jt:64' JP_jt = reshape([mt1,mt2],5,5); */
    b_t3[0] = -t3 * t4 * in2[3] - t21_tmp * in2[4];
    b_t3[1] = t3 * in2[4];
    t3_tmp = -t2 * t3;
    b_t3[2] = t3_tmp * in2[3] + t24_tmp * in2[4];
    b_t3[3] = 0.0;
    b_t3[4] = 0.0;
    b_t3[5] = t3_tmp * in2[4] + t24_tmp * in2[3];
    b_t3[6] = -t5 * in2[4];
    b_t3[7] = t21_tmp * in2[3] + t20_tmp * in2[4];
    b_t3[8] = 0.0;
    b_t3[9] = 0.0;
    b_t3[10] = t2 * in2[3];
    b_t3[11] = 0.0;
    b_t3[12] = -t4 * in2[3];
    b_t3[13] = 0.0;
    b_t3[14] = 0.0;
    b_t3_tmp = ((t9_tmp * t3 + t17_tmp * t6) + -(t13_tmp * t5)) + -(t21_tmp * t7);
    b_t3[15] = (((-in2[3] * ((((b_t3_tmp + (&in3[0][0])[9] * t2) + (&in3[0][0])[11] * t4) +
                              (&in3[0][0])[14] * t4) +
                             t4 * t8) +
                  t2 * in2[2]) +
                 t28 * in2[4]) -
                t20_tmp * in2[0]) +
               t24_tmp * in2[1];
    b_t3[16] = 0.0;
    b_t3[17] =
        (((-t4 * in2[2] + t27 * in2[4]) -
          in2[3] *
              (((((((-t12 + t16) - t20) + t24) - (&in3[0][0])[9] * t4) + (&in3[0][0])[11] * t2) +
                (&in3[0][0])[14] * t2) +
               t2 * t8)) -
         t17_tmp * in2[0]) +
        t21_tmp * in2[1];
    b_t3[18] = 0.0;
    b_t3[19] = 0.0;
    b_t3[20] = ((-in2[4] * b_t3_tmp + t28 * in2[3]) - t17_tmp * in2[1]) - t21_tmp * in2[0];
    b_t3[21] = (-in2[4] * (((t28_tmp + (&in3[0][0])[12] * t5) + t3 * t7) + t5 * t6) + t3 * in2[0]) -
               t5 * in2[1];
    b_t3[22] = ((t27 * in2[3] + in2[4] * (((t12 - t16) + t20) - t24)) + t20_tmp * in2[1]) +
               t24_tmp * in2[0];
    b_t3[23] = 0.0;
    b_t3[24] = 0.0;
    for (i = 0; i < 5; i++) {
        for (i1 = 0; i1 < 5; i1++) {
            JP_jt[i][i1] = b_t3[i1 + 5 * i];
        }
    }
}

/*
 * function JP_tj = kin_xyzbc_tt_JP_tj(in1,in2,in3)
 *
 * kin_xyzbc_tt_JP_tj
 *     JP_tj = kin_xyzbc_tt_JP_tj(IN1,IN2,IN3)
 *
 * Arguments    : const double in1[5]
 *                const double in2[5]
 *                double in3[5][3]
 *                double JP_tj[5][5]
 * Return Type  : void
 */
void kin_xyzbc_tt_JP_tj(const double in1[5], const double in2[5], double in3[5][3],
                        double JP_tj[5][5])
{
    double b_in2[25];
    double b_in2_tmp;
    double c_in2_tmp;
    double d_in2_tmp;
    double e_in2_tmp;
    double f_in2_tmp;
    double in2_tmp;
    double t10;
    double t11;
    double t12_tmp;
    double t13;
    double t13_tmp;
    double t15_tmp;
    double t18;
    double t18_tmp;
    double t2;
    double t21;
    double t22;
    double t3;
    double t4;
    double t5;
    double t9;
    int i;
    int i1;
    /*     This function was generated by the Symbolic Math Toolbox version 9.1. */
    /*     07-Nov-2023 14:54:36 */
    /* Jacobian first derivative ( Forward Kinematics ) :  */
    /* INPUTS :  */
    /* 	r_j    (5x1) : pose vector( joint space ) */
    /* 	v_j    (5x1) : speed vector( joint space ) */
    /* 	a_j    (5x1) : acceleration vector( joint space ) */
    /* 	p      (3x5) : parameters */
    /* OUTPUTS :  */
    /* 	M      (5x5) : resulting matrix */
    /* 'kin_xyzbc_tt_JP_tj:17' b = in1(4,:); */
    /* 'kin_xyzbc_tt_JP_tj:18' c = in1(5,:); */
    /* 'kin_xyzbc_tt_JP_tj:19' jp1 = in2(1,:); */
    /* 'kin_xyzbc_tt_JP_tj:20' jp2 = in2(2,:); */
    /* 'kin_xyzbc_tt_JP_tj:21' jp3 = in2(3,:); */
    /* 'kin_xyzbc_tt_JP_tj:22' jp4 = in2(4,:); */
    /* 'kin_xyzbc_tt_JP_tj:23' jp5 = in2(5,:); */
    /* 'kin_xyzbc_tt_JP_tj:24' offB1 = in3(10); */
    /* 'kin_xyzbc_tt_JP_tj:25' offB2 = in3(11); */
    /* 'kin_xyzbc_tt_JP_tj:26' offC1 = in3(13); */
    /* 'kin_xyzbc_tt_JP_tj:27' offB3 = in3(12); */
    /* 'kin_xyzbc_tt_JP_tj:28' offC2 = in3(14); */
    /* 'kin_xyzbc_tt_JP_tj:29' offC3 = in3(15); */
    /* 'kin_xyzbc_tt_JP_tj:30' offM1 = in3(1); */
    /* 'kin_xyzbc_tt_JP_tj:31' offM2 = in3(2); */
    /* 'kin_xyzbc_tt_JP_tj:32' offM3 = in3(3); */
    /* 'kin_xyzbc_tt_JP_tj:33' offT1 = in3(4); */
    /* 'kin_xyzbc_tt_JP_tj:34' offT2 = in3(5); */
    /* 'kin_xyzbc_tt_JP_tj:35' offT3 = in3(6); */
    /* 'kin_xyzbc_tt_JP_tj:36' x = in1(1,:); */
    /* 'kin_xyzbc_tt_JP_tj:37' y = in1(2,:); */
    /* 'kin_xyzbc_tt_JP_tj:38' z = in1(3,:); */
    /* 'kin_xyzbc_tt_JP_tj:39' t2 = cos(b); */
    t2 = cos(in1[3]);
    /* 'kin_xyzbc_tt_JP_tj:40' t3 = cos(c); */
    t3 = cos(in1[4]);
    /* 'kin_xyzbc_tt_JP_tj:41' t4 = sin(b); */
    t4 = sin(in1[3]);
    /* 'kin_xyzbc_tt_JP_tj:42' t5 = sin(c); */
    t5 = sin(in1[4]);
    /* 'kin_xyzbc_tt_JP_tj:43' t6 = -offM1; */
    /* 'kin_xyzbc_tt_JP_tj:44' t7 = -offM2; */
    /* 'kin_xyzbc_tt_JP_tj:45' t8 = -offM3; */
    /* 'kin_xyzbc_tt_JP_tj:46' t9 = offB1+offC1+offT1+t6+x; */
    t9 = ((((&in3[0][0])[9] + (&in3[0][0])[12]) + (&in3[0][0])[3]) + -(&in3[0][0])[0]) + in1[0];
    /* 'kin_xyzbc_tt_JP_tj:47' t10 = offB2+offC2+offT2+t7+y; */
    t10 = ((((&in3[0][0])[10] + (&in3[0][0])[13]) + (&in3[0][0])[4]) + -(&in3[0][0])[1]) + in1[1];
    /* 'kin_xyzbc_tt_JP_tj:48' t11 = offB3+offC3+offT3+t8+z; */
    t11 = ((((&in3[0][0])[11] + (&in3[0][0])[14]) + (&in3[0][0])[5]) + -(&in3[0][0])[2]) + in1[2];
    /* 'kin_xyzbc_tt_JP_tj:49' t12 = t4.*t5.*t11; */
    t12_tmp = t4 * t5;
    /* 'kin_xyzbc_tt_JP_tj:50' t13 = t2.*t3.*t9; */
    t13_tmp = t2 * t3;
    t13 = t13_tmp * t9;
    /* 'kin_xyzbc_tt_JP_tj:51' t14 = t2.*t3.*t11; */
    /* 'kin_xyzbc_tt_JP_tj:52' t15 = t2.*t5.*t9; */
    t15_tmp = t2 * t5;
    /* 'kin_xyzbc_tt_JP_tj:53' t16 = t3.*t4.*t9; */
    /* 'kin_xyzbc_tt_JP_tj:54' t17 = t2.*t5.*t11; */
    /* 'kin_xyzbc_tt_JP_tj:55' t18 = t3.*t4.*t11; */
    t18_tmp = t3 * t4;
    t18 = t18_tmp * t11;
    /* 'kin_xyzbc_tt_JP_tj:56' t19 = t4.*t5.*t9; */
    /* 'kin_xyzbc_tt_JP_tj:57' t20 = -t15; */
    /* 'kin_xyzbc_tt_JP_tj:58' t21 = t14+t16; */
    t21 = t13_tmp * t11 + t18_tmp * t9;
    /* 'kin_xyzbc_tt_JP_tj:59' t22 = t17+t19; */
    t22 = t15_tmp * t11 + t12_tmp * t9;
    /* 'kin_xyzbc_tt_JP_tj:60' mt1 =
     * [-jp4.*t3.*t4-jp5.*t2.*t5,-jp5.*t2.*t3+jp4.*t4.*t5,jp4.*t2,0.0,0.0,jp5.*t3,-jp5.*t5,0.0,0.0,0.0,-jp4.*t2.*t3+jp5.*t4.*t5,jp4.*t2.*t5+jp5.*t3.*t4,-jp4.*t4,0.0,0.0,jp5.*t22-jp4.*(t13-t18)-jp1.*t3.*t4-jp3.*t2.*t3,-jp4.*(t12+t20)+jp5.*t21+jp1.*t4.*t5+jp3.*t2.*t5,jp1.*t2-jp3.*t4-jp4.*(t2.*t11+t4.*t9),0.0,0.0,jp5.*(-t13+t18+offB1.*t3+offB2.*t5-t5.*t10)+jp2.*t3+jp4.*t22-jp1.*t2.*t5+jp3.*t4.*t5];
     */
    /* 'kin_xyzbc_tt_JP_tj:61' mt2 =
     * [-jp2.*t5+jp4.*t21-jp5.*(t12+t20-offB2.*t3+offB1.*t5+t3.*t10)-jp1.*t2.*t3+jp3.*t3.*t4,0.0,0.0,0.0];
     */
    /* 'kin_xyzbc_tt_JP_tj:62' JP_tj = reshape([mt1,mt2],5,5); */
    b_in2[0] = -in2[3] * t3 * t4 - in2[4] * t2 * t5;
    b_in2[1] = -in2[4] * t2 * t3 + in2[3] * t4 * t5;
    in2_tmp = in2[3] * t2;
    b_in2[2] = in2_tmp;
    b_in2[3] = 0.0;
    b_in2[4] = 0.0;
    b_in2_tmp = in2[4] * t3;
    b_in2[5] = b_in2_tmp;
    b_in2[6] = -in2[4] * t5;
    b_in2[7] = 0.0;
    b_in2[8] = 0.0;
    b_in2[9] = 0.0;
    b_in2[10] = -in2[3] * t2 * t3 + in2[4] * t4 * t5;
    b_in2[11] = in2_tmp * t5 + b_in2_tmp * t4;
    b_in2[12] = -in2[3] * t4;
    b_in2[13] = 0.0;
    b_in2[14] = 0.0;
    c_in2_tmp = in2[2] * t2;
    b_in2[15] = ((in2[4] * t22 - in2[3] * (t13 - t18)) - in2[0] * t3 * t4) - c_in2_tmp * t3;
    d_in2_tmp = t12_tmp * t11 + -(t15_tmp * t9);
    b_in2[16] = ((-in2[3] * d_in2_tmp + in2[4] * t21) + in2[0] * t4 * t5) + c_in2_tmp * t5;
    e_in2_tmp = in2[0] * t2;
    f_in2_tmp = in2[2] * t4;
    b_in2[17] = (e_in2_tmp - f_in2_tmp) - in2[3] * (t2 * t11 + t4 * t9);
    b_in2[18] = 0.0;
    b_in2[19] = 0.0;
    b_in2[20] =
        (((in2[4] * ((((-t13 + t18) + (&in3[0][0])[9] * t3) + (&in3[0][0])[10] * t5) - t5 * t10) +
           in2[1] * t3) +
          in2[3] * t22) -
         e_in2_tmp * t5) +
        f_in2_tmp * t5;
    b_in2[21] =
        (((-in2[1] * t5 + in2[3] * t21) -
          in2[4] * (((d_in2_tmp - (&in3[0][0])[10] * t3) + (&in3[0][0])[9] * t5) + t3 * t10)) -
         e_in2_tmp * t3) +
        in2[2] * t3 * t4;
    b_in2[22] = 0.0;
    b_in2[23] = 0.0;
    b_in2[24] = 0.0;
    for (i = 0; i < 5; i++) {
        for (i1 = 0; i1 < 5; i1++) {
            JP_tj[i][i1] = b_in2[i1 + 5 * i];
        }
    }
}

/*
 * function J_jt = kin_xyzbc_tt_J_jt(in1,in2)
 *
 * kin_xyzbc_tt_J_jt
 *     J_jt = kin_xyzbc_tt_J_jt(IN1,IN2)
 *
 * Arguments    : const double in1[5]
 *                double in2[5][3]
 *                double J_jt[5][5]
 * Return Type  : void
 */
void kin_xyzbc_tt_J_jt(const double in1[5], double in2[5][3], double J_jt[5][5])
{
    double J_jt_tmp;
    double b_J_jt_tmp;
    double c_J_jt_tmp;
    double d_J_jt_tmp;
    double e_J_jt_tmp;
    double f_J_jt_tmp;
    double t2;
    double t3;
    double t4;
    double t5;
    double t6;
    double t7;
    double t8;
    /*     This function was generated by the Symbolic Math Toolbox version 9.1. */
    /*     07-Nov-2023 14:54:34 */
    /* Jacobian Kinematics ( Inverse Kinematics ) :  */
    /* INPUTS :  */
    /* 	r_j    (5x1) : pose vector( joint space ) */
    /* 	v_j    (5x1) : speed vector( joint space ) */
    /* 	p      (3x5) : parameters */
    /* OUTPUTS :  */
    /* 	M      (5x5) : resulting matrix */
    /* 'kin_xyzbc_tt_J_jt:16' b = in1(4,:); */
    /* 'kin_xyzbc_tt_J_jt:17' c = in1(5,:); */
    /* 'kin_xyzbc_tt_J_jt:18' offB1 = in2(10); */
    /* 'kin_xyzbc_tt_J_jt:19' offC1 = in2(13); */
    /* 'kin_xyzbc_tt_J_jt:20' offB3 = in2(12); */
    /* 'kin_xyzbc_tt_J_jt:21' offC2 = in2(14); */
    /* 'kin_xyzbc_tt_J_jt:22' offC3 = in2(15); */
    /* 'kin_xyzbc_tt_J_jt:23' offP1 = in2(7); */
    /* 'kin_xyzbc_tt_J_jt:24' offP2 = in2(8); */
    /* 'kin_xyzbc_tt_J_jt:25' offP3 = in2(9); */
    /* 'kin_xyzbc_tt_J_jt:26' x = in1(1,:); */
    /* 'kin_xyzbc_tt_J_jt:27' y = in1(2,:); */
    /* 'kin_xyzbc_tt_J_jt:28' z = in1(3,:); */
    /* 'kin_xyzbc_tt_J_jt:29' t2 = cos(b); */
    t2 = cos(in1[3]);
    /* 'kin_xyzbc_tt_J_jt:30' t3 = cos(c); */
    t3 = cos(in1[4]);
    /* 'kin_xyzbc_tt_J_jt:31' t4 = sin(b); */
    t4 = sin(in1[3]);
    /* 'kin_xyzbc_tt_J_jt:32' t5 = sin(c); */
    t5 = sin(in1[4]);
    /* 'kin_xyzbc_tt_J_jt:33' t6 = offP1+x; */
    t6 = in1[0] + (&in2[0][0])[6];
    /* 'kin_xyzbc_tt_J_jt:34' t7 = offP2+y; */
    t7 = in1[1] + (&in2[0][0])[7];
    /* 'kin_xyzbc_tt_J_jt:35' t8 = offP3+z; */
    t8 = in1[2] + (&in2[0][0])[8];
    /* 'kin_xyzbc_tt_J_jt:36' J_jt =
     * reshape([t2.*t3,t5,-t3.*t4,0.0,0.0,-t2.*t5,t3,t4.*t5,0.0,0.0,t4,0.0,t2,0.0,0.0,-offB1.*t4+offB3.*t2+offC3.*t2+t2.*t8-offC1.*t3.*t4+offC2.*t4.*t5-t3.*t4.*t6+t4.*t5.*t7,0.0,-offB1.*t2-offB3.*t4-offC3.*t4-t4.*t8-offC1.*t2.*t3+offC2.*t2.*t5-t2.*t3.*t6+t2.*t5.*t7,1.0,0.0,-offC2.*t2.*t3-offC1.*t2.*t5-t2.*t3.*t7-t2.*t5.*t6,offC1.*t3-offC2.*t5+t3.*t6-t5.*t7,offC2.*t3.*t4+offC1.*t4.*t5+t3.*t4.*t7+t4.*t5.*t6,0.0,1.0],[5,5]);
     */
    J_jt_tmp = t2 * t3;
    J_jt[0][0] = J_jt_tmp;
    J_jt[0][1] = t5;
    J_jt[0][2] = -t3 * t4;
    J_jt[0][3] = 0.0;
    J_jt[0][4] = 0.0;
    J_jt[1][0] = -t2 * t5;
    J_jt[1][1] = t3;
    b_J_jt_tmp = t4 * t5;
    J_jt[1][2] = b_J_jt_tmp;
    J_jt[1][3] = 0.0;
    J_jt[1][4] = 0.0;
    J_jt[2][0] = t4;
    J_jt[2][1] = 0.0;
    J_jt[2][2] = t2;
    J_jt[2][3] = 0.0;
    J_jt[2][4] = 0.0;
    c_J_jt_tmp = (&in2[0][0])[12] * t3;
    d_J_jt_tmp = t3 * t4;
    J_jt[3][0] =
        ((((((-(&in2[0][0])[9] * t4 + (&in2[0][0])[11] * t2) + (&in2[0][0])[14] * t2) + t2 * t8) -
           c_J_jt_tmp * t4) +
          (&in2[0][0])[13] * t4 * t5) -
         d_J_jt_tmp * t6) +
        b_J_jt_tmp * t7;
    J_jt[3][1] = 0.0;
    e_J_jt_tmp = (&in2[0][0])[12] * t2;
    f_J_jt_tmp = t2 * t5;
    J_jt[3][2] =
        ((((((-(&in2[0][0])[9] * t2 - (&in2[0][0])[11] * t4) - (&in2[0][0])[14] * t4) - t4 * t8) -
           e_J_jt_tmp * t3) +
          (&in2[0][0])[13] * t2 * t5) -
         J_jt_tmp * t6) +
        f_J_jt_tmp * t7;
    J_jt[3][3] = 1.0;
    J_jt[3][4] = 0.0;
    J_jt[4][0] =
        ((-(&in2[0][0])[13] * t2 * t3 - e_J_jt_tmp * t5) - J_jt_tmp * t7) - f_J_jt_tmp * t6;
    J_jt[4][1] = ((c_J_jt_tmp - (&in2[0][0])[13] * t5) + t3 * t6) - t5 * t7;
    J_jt[4][2] = (((&in2[0][0])[13] * t3 * t4 + (&in2[0][0])[12] * t4 * t5) + d_J_jt_tmp * t7) +
                 b_J_jt_tmp * t6;
    J_jt[4][3] = 0.0;
    J_jt[4][4] = 1.0;
}

/*
 * function J_tj = kin_xyzbc_tt_J_tj(in1,in2)
 *
 * kin_xyzbc_tt_J_tj
 *     J_tj = kin_xyzbc_tt_J_tj(IN1,IN2)
 *
 * Arguments    : const double in1[5]
 *                double in2[5][3]
 *                double J_tj[5][5]
 * Return Type  : void
 */
void kin_xyzbc_tt_J_tj(const double in1[5], double in2[5][3], double J_tj[5][5])
{
    double J_tj_tmp;
    double b_J_tj_tmp;
    double c_J_tj_tmp;
    double d_J_tj_tmp;
    double t10;
    double t11;
    double t2;
    double t3;
    double t4;
    double t5;
    double t9;
    /*     This function was generated by the Symbolic Math Toolbox version 9.1. */
    /*     07-Nov-2023 14:54:34 */
    /* Jacobian Kinematics ( Forward Kinematics ) :  */
    /* INPUTS :  */
    /* 	r_j    (5x1) : pose vector( joint space ) */
    /* 	v_j    (5x1) : speed vector( joint space ) */
    /* 	p      (3x5) : parameters */
    /* OUTPUTS :  */
    /* 	M      (5x5) : resulting matrix */
    /* 'kin_xyzbc_tt_J_tj:16' b = in1(4,:); */
    /* 'kin_xyzbc_tt_J_tj:17' c = in1(5,:); */
    /* 'kin_xyzbc_tt_J_tj:18' offB1 = in2(10); */
    /* 'kin_xyzbc_tt_J_tj:19' offB2 = in2(11); */
    /* 'kin_xyzbc_tt_J_tj:20' offC1 = in2(13); */
    /* 'kin_xyzbc_tt_J_tj:21' offB3 = in2(12); */
    /* 'kin_xyzbc_tt_J_tj:22' offC2 = in2(14); */
    /* 'kin_xyzbc_tt_J_tj:23' offC3 = in2(15); */
    /* 'kin_xyzbc_tt_J_tj:24' offM1 = in2(1); */
    /* 'kin_xyzbc_tt_J_tj:25' offM2 = in2(2); */
    /* 'kin_xyzbc_tt_J_tj:26' offM3 = in2(3); */
    /* 'kin_xyzbc_tt_J_tj:27' offT1 = in2(4); */
    /* 'kin_xyzbc_tt_J_tj:28' offT2 = in2(5); */
    /* 'kin_xyzbc_tt_J_tj:29' offT3 = in2(6); */
    /* 'kin_xyzbc_tt_J_tj:30' x = in1(1,:); */
    /* 'kin_xyzbc_tt_J_tj:31' y = in1(2,:); */
    /* 'kin_xyzbc_tt_J_tj:32' z = in1(3,:); */
    /* 'kin_xyzbc_tt_J_tj:33' t2 = cos(b); */
    t2 = cos(in1[3]);
    /* 'kin_xyzbc_tt_J_tj:34' t3 = cos(c); */
    t3 = cos(in1[4]);
    /* 'kin_xyzbc_tt_J_tj:35' t4 = sin(b); */
    t4 = sin(in1[3]);
    /* 'kin_xyzbc_tt_J_tj:36' t5 = sin(c); */
    t5 = sin(in1[4]);
    /* 'kin_xyzbc_tt_J_tj:37' t6 = -offM1; */
    /* 'kin_xyzbc_tt_J_tj:38' t7 = -offM2; */
    /* 'kin_xyzbc_tt_J_tj:39' t8 = -offM3; */
    /* 'kin_xyzbc_tt_J_tj:40' t9 = offB1+offC1+offT1+t6+x; */
    t9 = ((((&in2[0][0])[9] + (&in2[0][0])[12]) + (&in2[0][0])[3]) + -(&in2[0][0])[0]) + in1[0];
    /* 'kin_xyzbc_tt_J_tj:41' t10 = offB2+offC2+offT2+t7+y; */
    t10 = ((((&in2[0][0])[10] + (&in2[0][0])[13]) + (&in2[0][0])[4]) + -(&in2[0][0])[1]) + in1[1];
    /* 'kin_xyzbc_tt_J_tj:42' t11 = offB3+offC3+offT3+t8+z; */
    t11 = ((((&in2[0][0])[11] + (&in2[0][0])[14]) + (&in2[0][0])[5]) + -(&in2[0][0])[2]) + in1[2];
    /* 'kin_xyzbc_tt_J_tj:43' J_tj =
     * reshape([t2.*t3,-t2.*t5,t4,0.0,0.0,t5,t3,0.0,0.0,0.0,-t3.*t4,t4.*t5,t2,0.0,0.0,-t2.*t3.*t11-t3.*t4.*t9,t2.*t5.*t11+t4.*t5.*t9,t2.*t9-t4.*t11,1.0,0.0,-offB2.*t3+offB1.*t5+t3.*t10-t2.*t5.*t9+t4.*t5.*t11,offB1.*t3+offB2.*t5-t5.*t10-t2.*t3.*t9+t3.*t4.*t11,0.0,0.0,1.0],[5,5]);
     */
    J_tj_tmp = t2 * t3;
    J_tj[0][0] = J_tj_tmp;
    J_tj[0][1] = -t2 * t5;
    J_tj[0][2] = t4;
    J_tj[0][3] = 0.0;
    J_tj[0][4] = 0.0;
    J_tj[1][0] = t5;
    J_tj[1][1] = t3;
    J_tj[1][2] = 0.0;
    J_tj[1][3] = 0.0;
    J_tj[1][4] = 0.0;
    J_tj[2][0] = -t3 * t4;
    b_J_tj_tmp = t4 * t5;
    J_tj[2][1] = b_J_tj_tmp;
    J_tj[2][2] = t2;
    J_tj[2][3] = 0.0;
    J_tj[2][4] = 0.0;
    c_J_tj_tmp = t3 * t4;
    J_tj[3][0] = -t2 * t3 * t11 - c_J_tj_tmp * t9;
    d_J_tj_tmp = t2 * t5;
    J_tj[3][1] = d_J_tj_tmp * t11 + b_J_tj_tmp * t9;
    J_tj[3][2] = t2 * t9 - t4 * t11;
    J_tj[3][3] = 1.0;
    J_tj[3][4] = 0.0;
    J_tj[4][0] = (((-(&in2[0][0])[10] * t3 + (&in2[0][0])[9] * t5) + t3 * t10) - d_J_tj_tmp * t9) +
                 b_J_tj_tmp * t11;
    J_tj[4][1] = ((((&in2[0][0])[9] * t3 + (&in2[0][0])[10] * t5) - t5 * t10) - J_tj_tmp * t9) +
                 c_J_tj_tmp * t11;
    J_tj[4][2] = 0.0;
    J_tj[4][3] = 0.0;
    J_tj[4][4] = 1.0;
}

/*
 * function piece = kin_xyzbc_tt_forward(in1,in2)
 *
 * KIN_XYZBC_TT_FORWARD
 *     PIECE = KIN_XYZBC_TT_FORWARD(IN1,IN2)
 *
 * Arguments    : const double in1[5]
 *                double in2[5][3]
 *                double piece[5]
 * Return Type  : void
 */
void kin_xyzbc_tt_forward(const double in1[5], double in2[5][3], double piece[5])
{
    double t10;
    double t11;
    double t2;
    double t3;
    double t4;
    double t5;
    double t9;
    /*     This function was generated by the Symbolic Math Toolbox version 9.1. */
    /*     07-Nov-2023 14:54:33 */
    /* Forward Kinematics :  */
    /* INPUTS :  */
    /* 	r_j    (5x1) : pose vector( joint space ) */
    /* 	p      (3x5) : parameters */
    /* OUTPUTS :  */
    /* 	r_t    (5x1) : pose vector ( piece frame ) */
    /* 'kin_xyzbc_tt_forward:15' b = in1(4,:); */
    /* 'kin_xyzbc_tt_forward:16' c = in1(5,:); */
    /* 'kin_xyzbc_tt_forward:17' offB1 = in2(10); */
    /* 'kin_xyzbc_tt_forward:18' offB2 = in2(11); */
    /* 'kin_xyzbc_tt_forward:19' offC1 = in2(13); */
    /* 'kin_xyzbc_tt_forward:20' offB3 = in2(12); */
    /* 'kin_xyzbc_tt_forward:21' offC2 = in2(14); */
    /* 'kin_xyzbc_tt_forward:22' offC3 = in2(15); */
    /* 'kin_xyzbc_tt_forward:23' offM1 = in2(1); */
    /* 'kin_xyzbc_tt_forward:24' offM2 = in2(2); */
    /* 'kin_xyzbc_tt_forward:25' offM3 = in2(3); */
    /* 'kin_xyzbc_tt_forward:26' offP1 = in2(7); */
    /* 'kin_xyzbc_tt_forward:27' offP2 = in2(8); */
    /* 'kin_xyzbc_tt_forward:28' offP3 = in2(9); */
    /* 'kin_xyzbc_tt_forward:29' offT1 = in2(4); */
    /* 'kin_xyzbc_tt_forward:30' offT2 = in2(5); */
    /* 'kin_xyzbc_tt_forward:31' offT3 = in2(6); */
    /* 'kin_xyzbc_tt_forward:32' x = in1(1,:); */
    /* 'kin_xyzbc_tt_forward:33' y = in1(2,:); */
    /* 'kin_xyzbc_tt_forward:34' z = in1(3,:); */
    /* 'kin_xyzbc_tt_forward:35' t2 = cos(b); */
    t2 = cos(in1[3]);
    /* 'kin_xyzbc_tt_forward:36' t3 = cos(c); */
    t3 = cos(in1[4]);
    /* 'kin_xyzbc_tt_forward:37' t4 = sin(b); */
    t4 = sin(in1[3]);
    /* 'kin_xyzbc_tt_forward:38' t5 = sin(c); */
    t5 = sin(in1[4]);
    /* 'kin_xyzbc_tt_forward:39' t6 = -offM1; */
    /* 'kin_xyzbc_tt_forward:40' t7 = -offM2; */
    /* 'kin_xyzbc_tt_forward:41' t8 = -offM3; */
    /* 'kin_xyzbc_tt_forward:42' t9 = offB1+offC1+offT1+t6+x; */
    t9 = ((((&in2[0][0])[9] + (&in2[0][0])[12]) + (&in2[0][0])[3]) + -(&in2[0][0])[0]) + in1[0];
    /* 'kin_xyzbc_tt_forward:43' t10 = offB2+offC2+offT2+t7+y; */
    t10 = ((((&in2[0][0])[10] + (&in2[0][0])[13]) + (&in2[0][0])[4]) + -(&in2[0][0])[1]) + in1[1];
    /* 'kin_xyzbc_tt_forward:44' t11 = offB3+offC3+offT3+t8+z; */
    t11 = ((((&in2[0][0])[11] + (&in2[0][0])[14]) + (&in2[0][0])[5]) + -(&in2[0][0])[2]) + in1[2];
    /* 'kin_xyzbc_tt_forward:45' piece =
     * [-offC1-offP1-offB1.*t3-offB2.*t5+t5.*t10+t2.*t3.*t9-t3.*t4.*t11;-offC2-offP2-offB2.*t3+offB1.*t5+t3.*t10-t2.*t5.*t9+t4.*t5.*t11;-offB3-offC3-offP3+t2.*t11+t4.*t9;b;c];
     */
    piece[0] =
        (((((-(&in2[0][0])[12] - (&in2[0][0])[6]) - (&in2[0][0])[9] * t3) - (&in2[0][0])[10] * t5) +
          t5 * t10) +
         t2 * t3 * t9) -
        t3 * t4 * t11;
    piece[1] =
        (((((-(&in2[0][0])[13] - (&in2[0][0])[7]) - (&in2[0][0])[10] * t3) + (&in2[0][0])[9] * t5) +
          t3 * t10) -
         t2 * t5 * t9) +
        t4 * t5 * t11;
    piece[2] = (((-(&in2[0][0])[11] - (&in2[0][0])[14]) - (&in2[0][0])[8]) + t2 * t11) + t4 * t9;
    piece[3] = in1[3];
    piece[4] = in1[4];
}

/*
 * function joint = kin_xyzbc_tt_inverse(in1,in2)
 *
 * KIN_XYZBC_TT_INVERSE
 *     JOINT = KIN_XYZBC_TT_INVERSE(IN1,IN2)
 *
 * Arguments    : const double in1[5]
 *                double in2[5][3]
 *                double joint[5]
 * Return Type  : void
 */
void kin_xyzbc_tt_inverse(const double in1[5], double in2[5][3], double joint[5])
{
    double t2;
    double t3;
    double t4;
    double t5;
    double t6;
    double t7;
    double t8;
    /*     This function was generated by the Symbolic Math Toolbox version 9.1. */
    /*     07-Nov-2023 14:54:32 */
    /* Inverse Kinematics :  */
    /* INPUTS :  */
    /* 	r_t    (5x1) : pose vector ( piece frame ) */
    /* 	p      (3x5) : parameters */
    /* OUTPUTS :  */
    /* 	r_j    (5x1) : pose vector( joint space ) */
    /* 'kin_xyzbc_tt_inverse:15' b = in1(4,:); */
    /* 'kin_xyzbc_tt_inverse:16' c = in1(5,:); */
    /* 'kin_xyzbc_tt_inverse:17' offB1 = in2(10); */
    /* 'kin_xyzbc_tt_inverse:18' offC1 = in2(13); */
    /* 'kin_xyzbc_tt_inverse:19' offB3 = in2(12); */
    /* 'kin_xyzbc_tt_inverse:20' offC2 = in2(14); */
    /* 'kin_xyzbc_tt_inverse:21' offC3 = in2(15); */
    /* 'kin_xyzbc_tt_inverse:22' offM1 = in2(1); */
    /* 'kin_xyzbc_tt_inverse:23' offM2 = in2(2); */
    /* 'kin_xyzbc_tt_inverse:24' offM3 = in2(3); */
    /* 'kin_xyzbc_tt_inverse:25' offP1 = in2(7); */
    /* 'kin_xyzbc_tt_inverse:26' offP2 = in2(8); */
    /* 'kin_xyzbc_tt_inverse:27' offP3 = in2(9); */
    /* 'kin_xyzbc_tt_inverse:28' offT1 = in2(4); */
    /* 'kin_xyzbc_tt_inverse:29' offT2 = in2(5); */
    /* 'kin_xyzbc_tt_inverse:30' offT3 = in2(6); */
    /* 'kin_xyzbc_tt_inverse:31' x = in1(1,:); */
    /* 'kin_xyzbc_tt_inverse:32' y = in1(2,:); */
    /* 'kin_xyzbc_tt_inverse:33' z = in1(3,:); */
    /* 'kin_xyzbc_tt_inverse:34' t2 = cos(b); */
    t2 = cos(in1[3]);
    /* 'kin_xyzbc_tt_inverse:35' t3 = cos(c); */
    t3 = cos(in1[4]);
    /* 'kin_xyzbc_tt_inverse:36' t4 = sin(b); */
    t4 = sin(in1[3]);
    /* 'kin_xyzbc_tt_inverse:37' t5 = sin(c); */
    t5 = sin(in1[4]);
    /* 'kin_xyzbc_tt_inverse:38' t6 = offP1+x; */
    t6 = in1[0] + (&in2[0][0])[6];
    /* 'kin_xyzbc_tt_inverse:39' t7 = offP2+y; */
    t7 = in1[1] + (&in2[0][0])[7];
    /* 'kin_xyzbc_tt_inverse:40' t8 = offP3+z; */
    t8 = in1[2] + (&in2[0][0])[8];
    /* 'kin_xyzbc_tt_inverse:41' joint =
     * [-offB1-offC1+offM1-offT1+offB1.*t2+offB3.*t4+offC3.*t4+t4.*t8+offC1.*t2.*t3-offC2.*t2.*t5+t2.*t3.*t6-t2.*t5.*t7;-offC2+offM2-offT2+offC2.*t3+offC1.*t5+t3.*t7+t5.*t6;-offB3-offC3+offM3-offT3-offB1.*t4+offB3.*t2+offC3.*t2+t2.*t8-offC1.*t3.*t4+offC2.*t4.*t5-t3.*t4.*t6+t4.*t5.*t7;b;c];
     */
    joint[0] =
        ((((((((((-(&in2[0][0])[9] - (&in2[0][0])[12]) + (&in2[0][0])[0]) - (&in2[0][0])[3]) +
               (&in2[0][0])[9] * t2) +
              (&in2[0][0])[11] * t4) +
             (&in2[0][0])[14] * t4) +
            t4 * t8) +
           (&in2[0][0])[12] * t2 * t3) -
          (&in2[0][0])[13] * t2 * t5) +
         t2 * t3 * t6) -
        t2 * t5 * t7;
    joint[1] =
        (((((-(&in2[0][0])[13] + (&in2[0][0])[1]) - (&in2[0][0])[4]) + (&in2[0][0])[13] * t3) +
          (&in2[0][0])[12] * t5) +
         t3 * t7) +
        t5 * t6;
    joint[2] =
        ((((((((((-(&in2[0][0])[11] - (&in2[0][0])[14]) + (&in2[0][0])[2]) - (&in2[0][0])[5]) -
               (&in2[0][0])[9] * t4) +
              (&in2[0][0])[11] * t2) +
             (&in2[0][0])[14] * t2) +
            t2 * t8) -
           (&in2[0][0])[12] * t3 * t4) +
          (&in2[0][0])[13] * t4 * t5) -
         t3 * t4 * t6) +
        t4 * t5 * t7;
    joint[3] = in1[3];
    joint[4] = in1[4];
}

/*
 * Arguments    : void
 * Return Type  : void
 */
void kinematics_initialize(void)
{
}

/*
 * Arguments    : void
 * Return Type  : void
 */
void kinematics_terminate(void)
{
}

/*
 * File trailer for kinematics.c
 *
 * [EOF]
 */
